/*
*
* Timer.java - 
* Copyright (C) 2003 Ecoo Team
* valdes@loria.fr
* 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


package hero.util;

import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.management.InstanceAlreadyExistsException;
import javax.management.MBeanRegistrationException;
import javax.management.NotCompliantMBeanException;
import javax.management.MalformedObjectNameException;
import javax.management.InstanceNotFoundException;
import javax.management.NotificationBroadcaster;
import javax.management.MBeanServerFactory;
import javax.management.MBeanException;
import javax.management.ReflectionException;
import javax.naming.Context;
import org.objectweb.jonas.service.ServiceException;

//import objectweb
import org.objectweb.jonas.jmx.JmxService;
import org.objectweb.jonas.service.AbsServiceImpl;
import org.objectweb.jonas.service.ServiceManager;

public class Timer extends AbsServiceImpl implements hero.util.TimerMBean, NotificationBroadcaster {
    
	private MBeanServer mbeanServer = null;
	private MBeanServer server;
	private final static String SERVICE_NAME = "jonas:type=service,name=Timer";
	private ObjectName timerName;
	javax.management.timer.Timer timer;

		public void doInit(Context ctx) throws ServiceException {
			// Get the JMX Server via JMX Service
		   	try {
		              JmxService jmx = (JmxService) ServiceManager.getInstance().getJmxService();
 			      mbeanServer = jmx.getJmxServer();
			} catch (Exception e) {
			    //the JMX service may not be started
			    throw new ServiceException("JMX Server is not started...");
			}
		}
	public void doStart() throws ServiceException {
		try {
			// Register MailService MBean : MailServiceImplMBean
		    timer = new javax.management.timer.Timer();
	            mbeanServer.registerMBean(timer,new ObjectName(SERVICE_NAME));
		    server = MBeanServerFactory.createMBeanServer();
		    timerName = new ObjectName("jonas:type=service,name=Timer");
		    server.createMBean("javax.management.timer.Timer", timerName,new Object[0], new String[0]);
		    server.invoke(timerName, "start", new Object[0], new String[0]);				 
		    timer.start();
   	            System.out.println("Timer :: Start Service");

		} catch (MBeanException me) {
			throw new ServiceException("Cannot start the Timer Service (MBean Exception)" , me);
		} catch (ReflectionException re) {
			throw new ServiceException("Cannot start the Timer Service  (Reflexion Exception)" , re);
		} catch (InstanceNotFoundException infe) {
			throw new ServiceException("Cannot start the Timer Service (MBean Not Found)" , infe);
		} catch (InstanceAlreadyExistsException iae) {
			throw new ServiceException("Cannot start the Timer Service (Already Exists)" , iae);
		} catch (NotCompliantMBeanException ncmbe) {
			throw new ServiceException("Cannot start the Timer Service (MBean Not compliant error)" , ncmbe);
		} catch (MalformedObjectNameException mone) {
			throw new ServiceException("Cannot start the Timer Service (ObjectName Malformed)" , mone);
		}
	}

	public void doStop() throws ServiceException {

		if (mbeanServer != null) {
			try {
				mbeanServer.unregisterMBean(new ObjectName(SERVICE_NAME));
				server.invoke(timerName, "removeAllNotifications", new Object[0], new String[0]);
				server.invoke(timerName, "stop", new Object[0], new String[0]);
				server.unregisterMBean(timerName);
				MBeanServerFactory.releaseMBeanServer(server);
			} catch (InstanceNotFoundException infe) {
				throw new ServiceException("Cannot stop the Timer Service (MBean Not Found).", infe);
			} catch (Exception e) {
				throw new ServiceException("Cannot stop the Timer Service (JMX).", e);
			}
		}
		System.out.println("Timer :: Stop Service");
	}
	
}
