/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: LdapGroupMembers.java,v 1.1 2004/07/30 14:57:57 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// Use of BnLdap session Bean
import hero.interfaces.BnLdap;
import hero.interfaces.BnLdapHome;
import hero.interfaces.BnLdapUtil;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import java.util.*;


public class LdapGroupMembers implements hero.mapper.RoleMapperI {

    public void searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {
	
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();	    
	    System.out.println("[Search Group Members] BnRole name:"+roleName + " - Project name = " + projectName);
		ArrayList al =null;
		
		BnLdapHome home = null;
		try {
			home = BnLdapUtil.getHome();		      
		} catch (Exception e) {
		    System.err.println( "Cannot lookup BnLdapHome: " + e);
		    System.exit(2);
		}
	
		BnLdap t1 = null;
		try {
			// logs trace
		    System.out.println("Create a bean bnLdap");
		    t1 = home.create();
		} catch (Exception e) {
			throw new HeroException("Cannot create  BnLdapBean : " + e);
		}
		try {
		al = (ArrayList)t1.getGroupMembers(roleName);
		} catch (Exception e){
			throw new HeroException("Error getting group members for group: " + roleName + " " + e.getMessage());
		}
		try {
	
		if (al.size() != 0){

			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(projectName);		
			Iterator it = al.iterator();
			while (it.hasNext()){
				String userUid = (String)it.next();
				
				// add user to the project  instance (but not for the project model)
				projectsession.addUser(userUid);
				
				// logs trace
				System.out.println("Add user: " + userUid + " to project: " + projectName );
				
				// set the user role
				projectsession.setUserRole(userUid, roleName);
				// logs trace
				System.out.println("Set role: " + roleName + " to user: " + userUid );
			}
			projectsession.remove();
		}
		else {
			// log trace
			System.out.println("Warning: no members found in LDAP group: " + roleName);
		}
		
		} catch (Exception e) {		    
			throw new HeroException("Error setting role : " + roleName + " with mapper " + e.getMessage());
		}	
		
		try {
		    t1.remove();
		} catch (Exception e) {
			throw new HeroException("Error on removing BnLdapBean: "+e);
		}
	    
    } 

}















