/**
 *
 * Bonita
 * Copyright (C) 1999 Bull S.A.
 * Bull 68 route de versailles  78434 Louveciennes Cedex France
 * Further information: bonita@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *
--------------------------------------------------------------------------
 * $Id: Sample1CustomCustomerGroupMembers.java,v 1.1 2004/08/27 14:56:11 mvaldes Exp $
 *
--------------------------------------------------------------------------
 */

package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import java.util.*;


public class Sample1CustomCustomerGroupMembers implements hero.mapper.RoleMapperI {

    public void searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {
    		
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();
	    
	    // logs trace	    
	    System.out.println("[CustomCustomerGroupMembers] BnRole name:"+roleName + " - Project name = " + projectName);

		try {

			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(projectName);
			
			// Template to be completed / implemented ......								
			// add user to the project  instance (but not for the project model)
			 try {
		 		 projectsession.addUser("jack");
			 }catch(Exception e){System.out.println(e) ;}
								
			// set the user role
			 try {
	  		projectsession.setUserRole("jack","customer");
			 }catch(Exception e){System.out.println(e) ;}
						
			projectsession.remove();
		
		} catch (Exception e) {		    
			throw new HeroException("Error setting role : " + roleName + " with mapper " + e.getMessage());
		}				    
    } 

}















